﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/InterferenceManagementZoneType.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE_TYPE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE_TYPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'PERMANENT_CEN_DSRC_TOLLING'.
enum
{
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneType__PERMANENT_CEN_DSRC_TOLLING = 0
};

/// Constant 'TEMPORARY_CEN_DSRC_TOLLING'.
enum
{
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneType__TEMPORARY_CEN_DSRC_TOLLING = 1
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneType__UNAVAILABLE = 2
};

/// Constant 'URBAN_RAIL'.
enum
{
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneType__URBAN_RAIL = 3
};

/// Constant 'SATELLITE_STATION'.
enum
{
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneType__SATELLITE_STATION = 4
};

/// Constant 'FIXED_LINKS'.
enum
{
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneType__FIXED_LINKS = 5
};

/// Struct defined in msg/InterferenceManagementZoneType in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneType
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// InterferenceManagementZoneType ::= ENUMERATED {
  ///     permanentCenDsrcTolling (0),
  ///     temporaryCenDsrcTolling (1),
  ///     unavailable             (2),
  ///     urbanRail               (3),
  ///     satelliteStation        (4),
  ///     fixedLinks              (5),
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE defines the type of an interference management zone, so that an ITS-S can
  /// * assert the actions to do while passing by such zone (e.g. reduce the transmit power in case of a DSRC tolling station).
  /// * It is an extension of the type @ref ProtectedZoneType.
  /// *
  /// * The value shall be set to:
  /// * - 0 - `permanentCenDsrcTolling` - as specified in ETSI TS 102 792 [14],
  /// * - 1 - `temporaryCenDsrcTolling` - as specified in ETSI TS 102 792 [14],
  /// * - 2 - `unavailable`             - default value. Set to 2 for backwards compatibility with DSRC tolling,
  /// * - 3 - `urbanRail`               - as specified in ETSI TS 103 724 [13], clause 7,
  /// * - 4 - `satelliteStation`        - as specified in ETSI TS 103 724 [13], clause 7,
  /// * - 5 - `fixedLinks`              - as specified in ETSI TS 103 724 [13], clause 7.
  /// *
  /// * @category: Communication information
  /// * @revision: Created in V2.1.1
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneType;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneType.
typedef struct etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneType__Sequence
{
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneType * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneType__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE_TYPE__STRUCT_H_
