﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/OccupiedLanesWithConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__OCCUPIED_LANES_WITH_CONFIDENCE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__OCCUPIED_LANES_WITH_CONFIDENCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'LANE_POSITION_BASED_MIN_SIZE'.
enum
{
  etsi_its_cam_ts_msgs__msg__OccupiedLanesWithConfidence__LANE_POSITION_BASED_MIN_SIZE = 1
};

/// Constant 'LANE_POSITION_BASED_MAX_SIZE'.
enum
{
  etsi_its_cam_ts_msgs__msg__OccupiedLanesWithConfidence__LANE_POSITION_BASED_MAX_SIZE = 4
};

/// Constant 'MAP_BASED_MIN_SIZE'.
enum
{
  etsi_its_cam_ts_msgs__msg__OccupiedLanesWithConfidence__MAP_BASED_MIN_SIZE = 1
};

/// Constant 'MAP_BASED_MAX_SIZE'.
enum
{
  etsi_its_cam_ts_msgs__msg__OccupiedLanesWithConfidence__MAP_BASED_MAX_SIZE = 4
};

// Include directives for member types
// Member 'lane_position_based'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position_options__struct.h"
// Member 'map_based'
#include "etsi_its_cam_ts_msgs/msg/detail/map_position__struct.h"
// Member 'confidence'
#include "etsi_its_cam_ts_msgs/msg/detail/meta_information__struct.h"

/// Struct defined in msg/OccupiedLanesWithConfidence in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__OccupiedLanesWithConfidence
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// OccupiedLanesWithConfidence::= SEQUENCE {
  ///     lanePositionBased     SEQUENCE (SIZE(1..4)) OF LanePositionOptions,
  ///     mapBased              SEQUENCE (SIZE(1..4)) OF MapPosition  OPTIONAL,
  ///     confidence            MetaInformation,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF represents a set of lanes which are partially or fully occupied by an object or event at an externally defined reference position.
  /// *
  /// * @note: In contrast to @ref GeneralizedLanePosition, the dimension of the object or event area (width and length) is taken into account to determine the occupancy,
  /// * i.e. this DF describes the lanes which are blocked by an object or event and not the position of the object / event itself. A confidence is used to describe the
  /// * probability that exactly all the provided lanes are occupied.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field lanePositionBased: a set of up to `4` lanes that are partially or fully occupied by an object or event, ordered by increasing value of @ref LanePosition.
  /// * Lanes that are partially occupied can be described using the component lanePositionWithLateralDetails of @ref  Options, with the following constraints:
  /// * The distance to lane borders which are covered by the object / event shall be set to 0. Only the distances to the leftmost and/or rightmost border which are not covered by
  /// * the object / event shall be provided with values > 0. Those values shall be added to the respective instances of @ref LanePositionOptions, i.e. the first entry shall contain the component distanceToLeftBorder > 0 ,
  /// * and/or the last entry shall contain the component distanceToRightBorder > 0; the respective other components of these entries shall be set to 0.
  /// *
  /// * @field mapBased: optional lane information described in the context of a MAPEM as specified in ETSI TS 103 301.
  /// * If present, it shall describe the same lane(s) as listed in the component lanePositionBased, but using the lane identification of the MAPEM. This component can be used only if a
  /// * MAPEM is available for the reference position (e.g. on an intersection): In this case it is used as a synonym to the mandatory component lanePositionBased.
  /// *
  /// * @field confidence: mandatory confidence information for expressing the probability that all the provided lanes are occupied. It also provides information on how the lane
  /// * information were generated. If none of the sensors were used, the lane information is assumed to be derived directly from the absolute reference position and the related dimension.
  /// *
  /// * @category: Road Topology information
  /// * @revision: Created in V2.2.1
  etsi_its_cam_ts_msgs__msg__LanePositionOptions__Sequence lane_position_based;
  etsi_its_cam_ts_msgs__msg__MapPosition__Sequence map_based;
  bool map_based_is_present;
  etsi_its_cam_ts_msgs__msg__MetaInformation confidence;
} etsi_its_cam_ts_msgs__msg__OccupiedLanesWithConfidence;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__OccupiedLanesWithConfidence.
typedef struct etsi_its_cam_ts_msgs__msg__OccupiedLanesWithConfidence__Sequence
{
  etsi_its_cam_ts_msgs__msg__OccupiedLanesWithConfidence * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__OccupiedLanesWithConfidence__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__OCCUPIED_LANES_WITH_CONFIDENCE__STRUCT_H_
