﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/VruDeviceUsage.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VRU_DEVICE_USAGE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VRU_DEVICE_USAGE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruDeviceUsage__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruDeviceUsage__MAX = 15
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruDeviceUsage__UNAVAILABLE = 0
};

/// Constant 'OTHER'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruDeviceUsage__OTHER = 1
};

/// Constant 'IDLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruDeviceUsage__IDLE = 2
};

/// Constant 'LISTENING_TO_AUDIO'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruDeviceUsage__LISTENING_TO_AUDIO = 3
};

/// Constant 'TYPING'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruDeviceUsage__TYPING = 4
};

/// Constant 'CALLING'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruDeviceUsage__CALLING = 5
};

/// Constant 'PLAYING_GAMES'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruDeviceUsage__PLAYING_GAMES = 6
};

/// Constant 'READING'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruDeviceUsage__READING = 7
};

/// Constant 'VIEWING'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruDeviceUsage__VIEWING = 8
};

/// Struct defined in msg/VruDeviceUsage in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__VruDeviceUsage
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// VruDeviceUsage ::= INTEGER {
  ///     unavailable      (0),
  ///     other            (1),
  ///     idle             (2),
  ///     listeningToAudio (3),
  ///     typing           (4),
  ///     calling          (5),
  ///     playingGames     (6),
  ///     reading          (7),
  ///     viewing          (8)
  /// }(0..15)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents the possible usage conditions of the VRU device.
  ///
  /// * - The value shall be set to:
  /// * - 0 `unavailable`      - to indicate that the usage conditions are unavailable,
  /// * - 1 `other`            - to indicate that the VRU device is in a state not defined below,
  /// * - 2 `idle`             - to indicate that the human is currently not interacting with the device,
  /// * - 3 `listeningToAudio` - to indicate that any audio source other than calling is in use,
  /// * - 4 `typing`           - to indicate that the human is texting or performaing any other manual input activity,
  /// * - 5 `calling`          - to indicate that the VRU device is currently receiving a call,
  /// * - 6 `playingGames`     - to indicate that the human is playing games,
  /// * - 7 `reading`          - to indicate that the human is reading on the VRU device,
  /// * - 8 `viewing`          - to indicate that the human is watching dynamic content, including following navigation prompts, viewing videos or other visual contents that are not static.
  /// * - value 9 to 15        - are reserved for future usage.
  /// *
  /// * @category: VRU information
  /// * @revision: Created in V2.1.1, type changed from ENUMERATED to INTEGER in V2.2.1 and range changed from 0..255 to 0..15
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__VruDeviceUsage;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__VruDeviceUsage.
typedef struct etsi_its_cam_ts_msgs__msg__VruDeviceUsage__Sequence
{
  etsi_its_cam_ts_msgs__msg__VruDeviceUsage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__VruDeviceUsage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VRU_DEVICE_USAGE__STRUCT_H_
